require 'securerandom'

class Node
  attr_accessor :name, :type, :label, :rank
  NODE_TYPES = ['screen', 'email', 'pdf', 'command', 'helper']

  def initialize(type, label, index, effect_flag)
    @name = transform_to_name(type, label, index, effect_flag)
    @type = NODE_TYPES.include?(type) ? type : ''
    @label = label
    @rank = 0
  end

  def transform_to_name(type, label, index, effect_flag)
    label = 'node_' + SecureRandom.uuid if effect_flag
    label = label.gsub(/[-\s.]/, '') + index.to_s
    label.gsub(/[\/\'|\"|\*|\\]/, '_')
  end
end
