require 'tempfile'

class OutputGraphic
  def initialize(szenarios, output_file)
    @file = Tempfile.new(['processed', '.dot'])
    @szenarios = szenarios
    @processed_string = ''
    @output_file = output_file
  end

  def generate
    build_graph
    generate_processed_file(@processed_string)
    generate_graph(@output_file)
  end

  def build_graph
    graph = GraphWriter.new
    @processed_string = graph.build_string(@szenarios.reverse)
  end

  def generate_processed_file(processed_string)
    @file << processed_string
    @file.close
  end

  def generate_graph(output_file)
    FileUtils.mkdir_p File.dirname(output_file)
    file_ending = File.extname(output_file).delete('.')
    cmd = "dot -T#{file_ending} #{@file.path} -o #{output_file}"
    system(cmd)
    @file.unlink
  end
end
